include get.e
include bignum.e
without type_check

bignum n1, rootnum_bnform, res1, bigpow
sequence pow
atom biggestexact,dec, res, t
integer rootnum, base, oldbase, c

biggestexact = 9007199254740992
dec = -floor(biggestexact/5)
rootnum = 7
rootnum_bnform = bn_atomto_other(rootnum, gCURBASE)
base = rand(gcMAXBASE-1) + 1

puts(1,"Speed improvement by base conversion:\n")
puts(1,"calculating 12^100, 100 times\n")
t = time()
n1 = bn_atomto_other(12,10)
bigpow = bn_atomto_other(100,10)
for x = 1 to 100 by 1 do
   res1 = bn_power(n1, bigpow)
end for
t = time()-t
bn_shownum(res1) puts(1,"\n")
printf(1,"time in base 10: %f\n\n",{t})

puts(1,"calculating 12^100, 100 times in highest base supported\n")
t = time()
n1 = bn_atomto_other(12,gcMAXBASE)
bigpow = bn_atomto_other(100,gcMAXBASE)
oldbase = bn_set_base(gcMAXBASE)
for x = 1 to 100 by 1 do
   res1 = bn_power(n1, bigpow)
end for
res1 = bn_baseconv(res1,gcMAXBASE,10)
oldbase = bn_set_base(10)
t = time()-t
bn_shownum(res1) puts(1,"\n")
printf(1,"time in base %d: %f\n",{gcMAXBASE,t})
puts(1,"press ESC to quit, other to continue . . .")
c = wait_key()
puts(1,"\n")
if c = 27 then
   abort(0)
end if


puts(1,"\n\nPOWER TEST\n")
puts(1,"According to the machine:\n")
pow = {rand(100),rand(100),rand(100),rand(100),rand(100)}
for n = 2 to 6 by 1 do
   res = power(n, pow[n-1])
   printf(1,"%d^%d = %d\n",{n,pow[n-1],res})
end for

puts(1,"According to the bignum routines:\n")
for n = 2 to 6 by 1 do
   n1 = bn_atomto_other(n,10)
   res1 = bn_power(n1, bn_atomto_other(pow[n-1],10) )
   printf(1,"%d^%d = ",{n,pow[n-1]})
   bn_shownum(res1)    puts(1,"\n")
end for

puts(1,"press ESC to quit, other to finish . . .")
c = wait_key()
puts(1,"\n")
if c = 27 then
   abort(0)
end if


puts(1,"\n\nROOT TEST\n")
puts(1,"According to the machine:\n")
for n = biggestexact to 1 by dec do
   res = floor(power(n, 1/rootnum))
   printf(1,"closest integer under %dth root of %d = %d\n",{rootnum,n,res})
end for

puts(1,"According to the bignum routines:\n")
for n = biggestexact to 1 by dec do
   n1 = bn_atomto_other(n,10)
   res1 = bn_approxroot(n1,rootnum)
   printf(1,"closest integer under %dth root of %d = ",{rootnum,n})
   bn_shownum(res1)    puts(1,"\n")
end for
puts(1,"done\n")

